#!/usr/bin/perl

$| = 1;
$P = "dbamon_count.pl";

if ($ARGV[0] eq "Y")
{
  $first = "
    select
      \"tables\", 
      count(*)
    from
      systabnames;";
}

$sql = "$first
    select
      \"databases\", count(*)
    from
      sysdatabases;

    select
      \"dbspaces\", count(*)
    from
      sysdbspaces;

    select
      \"disks\", count(distinct fname) 
    from
      syschunks;

    select
      \"appldatabases\", count(*)
    from
      sysdatabases
    where 
      name not like \"sys%\";

    select 
      \"segshared\", 
      seg_osshmid 
    from 
      syssegments 
    where 
      seg_osshmid < 0;";

#
# Run dbaccess
#

system("echo '$sql' | dbaccess sysmaster");

#
# Run UX commands
#

system("onstat -V");
system("uname -a");
system("model");
system("echo 'MODE' `getconf SC_KERNEL_BITS`");

exit 0;
