sub histCreate
# Create a row in the Oracle dbamon.history table 
{
  ($caller, $h, $c, $p, $v) = @_;

  if ($use_oracle ne "Y") 
  {
    logit("histCreate() Use_Oracle != Y - returning",$h);
    return;
  }

  if ($v eq "" || $v < 0) 
  {
    $v = -1;   # Hmmmm?????
  }

  if ($iter_count == 1 || ($iter_count/10 == int($iter_count/10)))   # Do this on the first and every 10th iteration
  {
    #$rc = system("dbamon_ora_histupdate.pl I $mode $titlehist[$h] $hostname[$h] $dbmsout[$h] $c $p $v > $tmpfl8 2>&1");

    $statement  = "
      insert into dbamon.history
	(dbamonmode,instance,system,dbms,category,parm,value)
      values
        (\'$mode\',\'$titlehist[$h]\', \'$hostname[$h]\', \'$dbmsout[$h]\', \'$c\', \'$p\',$v)
    ";

    ##print "statement=$statement\n";
    runSQL($statement,1);
    ##print "sqlerror=$sqlerror sqlcode=$sqlcode\n";

    if ($sqlcode != 0)
    {
      if ($sqlcode == 1)
      {
	&logit("Normal Warning: Duplicate dbamon.history Row",$h);
	$returnrc = 2;
      }
      else
      {
	&error_msg('Insert_into_history_error');
      }
    }
    else
    {
      &logit("dbamon.history Data Created",$h);
    }
  }
  else
  {
    #$msg = sprintf("histCreate() Not this iteration (%s) - returning",$iter_count);
    #&logit($msg,$h);
  }
}

#-------------------------------------------------------------------------------
1;
