# -----------------------------------------------------------------------------
sub sqlUp
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[$thishost] = ""

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    $download_flag[$thishost] = 0;
    return;
  }

  # Check to see if  we need to create history data
  chop($filedate = `date +%C%y.%m.%d`);
  chop($filetime = `date +%H:%M:%S`);
  $hist_flag = 0;
  if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
  {
    &logit("Setting flag to create tblspace history data",$thishost);
    system("rm $tmpflt > /dev/null 2>&1");
    $hist_flag = 1;
  }

  $must_connect = 1;
  remsh("$perlpath[$thishost] \\temp\\dbamon_mssql.pl up",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  $dbstatus = "";
  $total_size = "";
  $total_used = "";

  &logDetails($thishost,"<h3>MSSQL Databases</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Database<br>Name<th>Space<br>Allocated<br>(MB)<th>Space<br>Used<br>(MB)</tr>");

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F1 eq "SQLVer:")      {  $sw_version[$thishost] = $F2 }
    if ($F1 eq "OSVer:")       {  $os_version[$thishost] = $F2 }
    if ($F1 eq "DBStatus:")    {  $dbstatus = $F2 }
    if ($F1 eq "AgentStatus:") {  $agentstatus = $F2 }
    if ($F1 eq "NumCPUs:")     {  $hw_processors[$thishost] = $F2 }
    if ($F1 eq "CPUModel:")    {  $hw_model[$thishost] = $F2 }
    if ($F1 eq "RAM:")         {  $hw_memory[$thishost] = $F2 }
    if ($F1 eq "SpaceAlloc:")  {  $total_size = $F2 }
    if ($F1 eq "SpaceUsed:")   {  $total_used = $F2 }
    if ($F1 eq "DB:")
    {
      $zF3 = sprintf "%9.2f",$F3;
      $zF4 = sprintf "%9.2f",$F4;
      &logDetails($thishost,"<tr><td>$F2<td align=right>$zF3<td align=right>$zF4</tr>");
      if ($hist_flag)
      {
	system("echo '$filedate $filetime $title[$thishost] $F2 . $F3 $F4 $dbms[$thishost]' >> $tmpflt");
      }

      # Create repository history data
      &histCreate("sqlUp()",$thishost,"SPC",$F2,$zF3,$zF4);
    }
  }
  close(TMPFL3);

  $ztotal_size = sprintf "%9.2f",$total_size;
  $ztotal_used = sprintf "%9.2f",$total_used;
  ##print "$ztotal_size $ztotal_used \n";
  &logDetails($thishost,"<tr><th bgcolor=slate>Total:<td align=right>$ztotal_size<td align=right>$ztotal_used</tr>");
  &logDetails($thishost,"</table><hr>");

  if ($sw_version[$thishost] lt $ver_mssql_low  || $ver_mssql_low eq "" ) { $ver_mssql_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] lt $ver_mssql_high || $ver_mssql_high eq "") { $ver_mssql_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;  
  $system_used[$thishost] = $total_used / 1000;  
  ##print "su=$system_used[$thishost] $title[$thishost] \n";
  $grand_total_size += ($total_size / 1000);  

  # Check status
  if ($dbstatus ne "UP")
  {
    $up[$thishost] = "N";

    if ($t_mustbeup[$thishost] eq "Y")
    {
      $msg = sprintf("!!! MSSQL Not Active: %s !!!",$dbstatus);
      $msgid = "DBA801C";
      $m_critical[$thishost]++;
      $short = "Down";
      &logit($msg,$thishost);
      &crit_msg($msg,$thishost,$tmpfl3);
    }
    else
    {
      $msg = sprintf("... MSSQL Not Active: %s ...",$dbstatus);
      $msgid = "DBA802W";
      &logit($msg,$thishost);
      $short = "Down";
      &info_msg($msg,$thishost,$tmpfl3);
      $m_info[$thishost]++;
    }
  }
  else
  {
    $up[$thishost] = "Y";

    logit("OK",$thishost);
    if ($agentstatus ne "UP")
    {
      #$msg = sprintf("!!! MSSQL Agent Service Not Active !!!");
      #$msgid = "DBA803C";
      #$m_critical[$thishost]++;
      #$short = "AgentDown";
      #&logit($msg,$thishost);
      #&crit_msg($msg,$thishost,$tmpfl3);
      &event("C",$thishost,"MSSQL Agent Service Not Active","AgentDown","DBA803C",$tmpfl3);
    }
  }

  #&history_dummy($thishost);

  &logDetails($thishost,"<h3>MSSQL Instance Data</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");

  &logDetails($thishost,"<tr><td><b>MSSQL Version:<td align=right>$sw_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>MSSQL Up?<td align=right>$up[$thishost]<td>(Y or N)");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td><b>OS Type:<td align=right>$os[$thishost]");
  &logDetails($thishost,"<tr><td><b>OS Version:<td align=right>$os_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>OS Mode:<td align=right>$os_mode[$thishost]<td>(32, 64 or Blank)");
  &logDetails($thishost,"<tr><td><b>Server Type:<td align=right>$hw_model[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Memory (MB):<td align=right>$hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Processor Count:<td align=right>$hw_processors[$thishost]");
  &logDetails($thishost,"</table><hr>");

  if ($hist_flag)
  {
    &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
    system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
  }
}
# -----------------------------------------------------------------------------
1;
