#-------------------------------------------------------------------------------
sub sumprint
# Write lines to the summary, and to Oracle
{
  ($sum_h,$sum_string,$sum_flag,$sum_size) = @_;

  if ($sum_string ne "")
  {
    print HTMLSYS "$sum_string\n";
  }

  if ($use_oracle ne "Y") 
  {
    return;
  }

  if ($sum_h ne "")
  {
    $sum_long .= $sum_string;
  }
  
  if ($mode eq "")
  {
    $summode = "prod$dbamon_tasknum";
  }
  else
  {
    $summode = "$mode$dbamon_tasknum";
  }


  if ($sum_flag eq "S")
  {
    &logit("Start of Summary - Cleaning summary_detail, summary_tot and summary_dbms tables for this mode");
    $sum_long = "";

    #Test
    ##&logit("DEBUG BFore - Running: select count(*) from dbamon.summary_dbms where dbamonmode like '$summode';");
    #system("sqlplus /nolog <<!
    #  connect dbamon/dbamon
    #  set echo on
    #  set showmode both
    #  select count(*) from dbamon.summary_dbms where dbamonmode like '$summode';
    #  exit
    #!");

    $statement  = "delete from dbamon.summary_detail where dbamonmode like '$summode'";
    runSQL($statement);

    $statement  = "delete from dbamon.summary_tot where dbamonmode like '$summode'";
    runSQL($statement);

    $statement  = "delete from dbamon.summary_dbms where dbamonmode like '$summode'";
    runSQL($statement);

    #Test
    #&logit("DEBUG After - Running: select count(*) from dbamon.summary_dbms where dbamonmode like '$summode';");
    #system("sqlplus /nolog <<!
    #  connect dbamon/dbamon
    #  set echo on
    #  set showmode both
    #  select count(*) from dbamon.summary_dbms where dbamonmode like '$summode';
    #  exit
    #!");

  }

  if ($sum_flag eq "W")
  {
    $_ = $sum_long;
    s/\n/ /g;
    #s/'/"/g;
    #s/'/''/g;
    $sum_long = $_;

    if ($sum_size eq "") { $sum_size = 0; }

    $z = length($sum_long);
    ##print "length(sum_long)=$z title=$title[$sum_h]\n";

    $statement  = "
      insert into dbamon.summary_detail
        (dbamonmode,system,dbms,title,spacealloc,htmlstring,id1,id2,id3,id4,serverloc,health)
      values
        (\'$summode\',\'$hostname[$sum_h]\', \'$dbmsout[$sum_h]\', \'$title[$sum_h]\', \'$sum_size\', ?, \'$id1[$sum_h]\', \'$id2[$sum_h]\',\'$id3[$sum_h]\',\'$id4[$sum_h]\',\'$serverloc[$sum_h]\',\'$health_flag[$sum_h]\')
    ";
    ##print "statement=$statement \n";

    $bind_1 = $sum_long;
    runSQLBind($statement);

    $sum_long = "";
  }

  if ($sum_flag eq "A")    #Alias entries
  {
    $a_dbms  = "(ServerAlias)";
    $a_title = "$alias(A)";

    $statement  = "
      insert into dbamon.summary_detail
        (dbamonmode,system,dbms,title,spacealloc,htmlstring,id1,id2,id3,id4,serverloc,health)
      values
        (\'$summode\',\'$alias\', \'$a_dbms\', \'$a_title\', \'0\', \'$alias_html\', \'\', \'\',\'\',\'\',\'$serverloc[$sum_h]\',\'-1\')
    ";

    ##print "statement=$statement \n";
    runSQL($statement);
  }
}
#-------------------------------------------------------------------------------
1;
