#------------------------------------------------------------------------------
sub user_msg
#
# User Event
#
{
  ($m, $h, $f) = @_;
  $msgsave = $msgid;
  $msgmod = "DBAmon|$title[$h]| $m";

  &log_msg($m,$h);
  if ($f ne "") 
  {
    &log_file($f,$h);
  }

  if ($short ne "")
  {
    $z = "<font color=lime>$short</font>";
    if (index($msgs[$h],$z) == -1) { $msgs[$h] .= "$z "; }
    $short = "";
  }

  if ($arg eq "ztest")
  {
    logit("Test Mode - NOT Mailing message",$h);
    return 0;
  }

  #
  # tmpfl5 will contain the header and text of message
  #

  chop($date = `date`);
  open(TMPFL5,  ">$tmpfl5") || &error_msg("Can't open output $tmpfl5 - $!");

  print TMPFL5 "--- DBAmon Critical Message Notification ---\n";
  print TMPFL5 "    Instance: $title[$h]\n";
  print TMPFL5 "        Date: $date\n\n";
  print TMPFL5 "$msg \n";

  if ($msgsave ne "")
  {
    print TMPFL5 "    For more information on this error, see:\n";
    print TMPFL5 "    $dbamon_home/errors.shtml#$msgsave\n\n";
  }

  if ($f ne "")
  {
    print TMPFL5 `cat $f`;
  }

  close(TMPFL5);

  # 
  # Parse list of userid into indiviual elements
  #

  ###user_elm[0] = split(userlist[$h_userlist[$h]],user_elm)
  $list_id = $h_userlist[$h];      # This is the Notify_List value for the isntance
  $_ = $userlist[$list_id];        # The notify list entry
  @user_elm = split;

  if ($debug_crit)
  {
    print "list_id=$list_id \n";
    print "entries=$_ \n";
    print "number of user_elm's=$#user_elm\n";
  }

  for ($i_mail=0; $i_mail<= $#user_elm; $i_mail++)
  {
    if ($debug_crit)
    {
      printf("Processing i_mail=%s user_elm[$i_mail]=%s\n",$i_mail,$user_elm[$i_mail])
    }

    if (substr($user_elm[$i_mail],0,1) eq "@")
    {
      $host = substr($user_elm[$i_mail],1);
      $msgtemp = sprintf("Sending postnote to host=%s",$host);
      &logit($msgtemp,$h);

      $rc = system("cat $tmpfl5 | $post_dir/clpostXm $host");
      if ($rc != 0) 
      {
        $msgtemp = sprintf("Postnote rc=%s",$rc);
        &logit($msgtemp,$h);
      }
      next;
    }

    $msgtemp = sprintf("Mailing user message to user=%s",$user_elm[$i_mail]);
    &logit($msgtemp,$h);

    $cmd = "cat $tmpfl5 |dbamon_mailer -m -s '$msgmod' $user_elm[$i_mail]";
    ##print "cmd=$cmd \n";

    if ($debug_crit)
    {
      printf("About to execute cmd=%s\n",$cmd);
    }
    $rc = system($cmd);
    if ($debug_crit) 
    { 
      printf("Mail rc=%s\n",$rc);
    }
  }
}
#------------------------------------------------------------------------------
1;
