# -----------------------------------------------------------------------------
sub sqlAlerts
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    return;
  }

  &remsh("$perlpath[$thishost] $probe[$thishost] checklog",$tmpfl3,$thishost);

  #system("cat $tmpfl3 ");
  system("cp $tmpfl3 /tmp/zdbamondiag.txt");

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  
  $sqlevent_flag = 0;
  $sqlevent_text = "";

  while(<TMPFL3>)
  {
    &parse;
    if ($F1 eq "Event:")  
    {
      $sqlevent_flag = 1;
    }
  }
  close(TMPFL3);
  
  if ($sqlevent_flag == 1)
  {
    &event("C",$thishost,"MSSQL EventLog Alert(s) Found","MSSQLEventLog","DBA651C",$tmpfl3);
  }
}
# -----------------------------------------------------------------------------
1;
