# -----------------------------------------------------------------------------
sub sqlUp
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[$thishost] = ""

  $titlehist[$thishost] = "?" if !$titlehist[$thishost];
  $title1[$thishost]    = "?" if !$title1[$thishost];

  #---- BB 28Jul06 - Changed defaults from 95/99 to 90/95
  $t_diskwarn[$thishost] = "90" if !$t_diskwarn[$thishost];
  $t_diskcrit[$thishost] = "95" if !$t_diskcrit[$thishost];

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  if ($g_history_to_file eq "Y")
  {
    # Check to see if  we need to create history data
    chop($filedate = `date +%C%y.%m.%d`);
    chop($filetime = `date +%H:%M:%S`);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Setting flag to create tblspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;
    }
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $must_connect = 1;
  remsh("$perlpath[$thishost] $probe[$thishost] up . $probe_parm[$thishost]",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");
  system("cp $tmpfl3 /tmp/dbamondebugmssql_$mode");

  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  $dbstatus = "";
  $agentstatus = "";
  $total_size = "";
  $total_used = "";

  $oldperl_kill = ""; 
  $oldperl_details = ""; 
  $oldperl_maxage = ""; 
  $oldperl_pids = ""; 
  $oldperl_cnt = 0; 

  $dbcount[$thishost] = "";
  $udbcount[$thishost] = "";
  $tlogdata[$thishost] = ();
  $drivedata[$thishost] = ();
  $diskdrivedata = "";

  $rmt_hostname[$thishost] = ""; 

  $os64bit[$thishost] = ""; 
  $mssql64bit[$thishost] = ""; 

  $cluster_name[$thishost] = ""; 
  $cluster_status[$thishost] = ""; 
  $cluster_onnode[$thishost] = ""; 
  $cluster_thisnodestatus[$thishost] = ""; 

  %dbsize = ();

  &logDetails($thishost,"<h3>MSSQL Databases</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Database<br>Name<th>$f_s Space<br>Allocated<br>(MB)<th>$f_s Space<br>Used<br>(MB)<th>$f_s Date<br>Last<br>Object Created<th>$f_s DB Attributes</tr>");

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F1 eq "SQLVer:")      
    { 
      $z = $F2;

      # convert from x.xx.xxx format for x.xx.xxxx
      $z =~ tr/\(/./;
      $z =~ tr/\)//d;
      @words = split(/\./,$z);
      if (length($words[2]) == 3)
      {
	$z =~ s/$words[2]/0$words[2]/g;
      }

      $sw_version[$thishost] = $z;
    }

    if ($F2 eq "DRIVESTATUS:")    
    {
      #---- dbamon_mssql.pl DRIVESTATUS: E 52094 43768 8326 84.02
      $drivedata[$thishost] .= $F0;
      $dr_drive = (split(/ /,$F0)) [2];
      $dr_size  = (split(/ /,$F0)) [3];
      $dr_used  = (split(/ /,$F0)) [4];
      $dr_free  = (split(/ /,$F0)) [5];
      $dr_pct   = (split(/ /,$F0)) [6];

      ##print "DRIVESTATUS $titleraw[$thishost] $F0" if $dr_pct >= 90;

      $color = "lightblue";

      if ($t_diskwarn[$thishost] && $t_diskwarn[$thishost] ne "N")
      {
        if ($dr_pct >= $t_diskcrit[$thishost])
        {
          &event("C",$thishost,"Drive $dr_drive is $dr_pct full (Critical threshold: $t_diskcrit[$thishost]%)","DriveFullC","DBA805",$tmpfl3);
          $color = "pink";
        }
        elsif ($dr_pct >= $t_diskwarn[$thishost])
        {
          &event("W",$thishost,"Drive $dr_drive is $dr_pct full (Warning threshold: $t_diskwarn[$thishost]%)","DriveFullW","DBA805",$tmpfl3);
          $color = "yellow";
        }
        else
        {
          $color = "lime";
        }
      }

      $diskdrivedata .= "
      <tr bgcolor=$color>
        <td>$f_s $dr_drive
        <td align=right>$f_s $dr_size
        <td align=right>$f_s $dr_used
        <td align=right>$f_s $dr_free
        <td align=right>$f_s ${dr_pct}%
      ";

    }

    if ($F2 eq "TLOG:")    
    {
      $tlogdata[$thishost] .= $F0;
      ##print "TLOG F0=$F0\n";
    }

    if ($F2 eq "OS64BIT:" && $F3 == 1)    
    {
      $os64bit[$thishost] .= "(64bit)";
    }
    if ($F2 eq "MSSQL64BIT:" && $F3 == 1)    
    {
      $mssql64bit[$thishost] .= "(64bit)";
    }

    if ($F2 eq "UPTIME:")  #---- New
    {
      $str_c = $F3;
      $str_n = $F4;
      $end_c = $F5;
      $end_n = $F6;
      &uptimeLog($thishost);
    }

    if ($F2 eq "OLDPERL:")    
    {
      $oldperl_details .= substr($F0,25); 
      $z = substr($F6,6); 
      $oldperl_maxage = $z if $z > $oldperl_maxage;
      $oldperl_cnt++;
      $zpid = substr($F3,4); 
      $oldperl_kill .= "<b>C:\\dbatools\\pskill $zpid</b>\n"; 
      $oldperl_pids .= "$zpid "; 
    }

    # print "DoubleTakeStatus: $doubletake_status\n";
    # print "DoubleTakeDir: $doubletake_dir\n";
    # print "DoubleTakeFile: $doubletake_file\n";
    # print "DoubleTakeFileAgeMins: $doubletake_fileage_mins\n";
    if ($F1 eq "DoubleTakeStatus:")      {  $doubletake_status[$thishost] = $F2 }
    if ($F1 eq "DoubleTakeDir:")         {  $doubletake_dir[$thishost] = $F2 }
    if ($F1 eq "DoubleTakeFile:")        {  $doubletake_file[$thishost] = $F2 }
    if ($F1 eq "DoubleTakeFileAgeMins:") {  $doubletake_fileage_mins[$thishost] = $F2 }

    # dbamon_mssql.pl CLUSTERNAME: LSCASQLTEST
    # dbamon_mssql.pl CLUSTERSTATUS: Online
    # dbamon_mssql.pl CLUSTERONNODE: WCOSDBT1
    # dbamon_mssql.pl CLUSTERTHISNODESTATUS: Passive
    if ($F2 eq "CLUSTERNAME:")           {  $cluster_name[$thishost] = $F3 }
    if ($F2 eq "CLUSTERSTATUS:")         {  $cluster_status[$thishost] = $F3 }
    if ($F2 eq "CLUSTERONNODE:")         {  $cluster_onnode[$thishost] = $F3 }
    if ($F2 eq "CLUSTERTHISNODESTATUS:") {  $cluster_thisnodestatus[$thishost] = $F3 }

    #---- Save DB attributes
    if ($F2 eq "DB_ATTRS:")    
    {  
      $zdb = lc $F3;
      $db_attrs[$thishost]{$zdb} = $F4; 
      ##print "db_attrs=$db_attrs[$thishost]{$F3} F3=$F3\n";
    }

    if ($F1 eq "OSVer:")       {  $os_version[$thishost] = $F2 }
    if ($F1 eq "DBStatus:")    {  $dbstatus = $F2 }
    if ($F1 eq "AgentStatus:") {  $agentstatus = $F2 }
    if ($F1 eq "NumCPUs:")     {  $hw_processors[$thishost] = $F2 }
    if ($F1 eq "CPUModel:")    {  $hw_model[$thishost] = $F2 }
    if ($F1 eq "RAM:")         {  $hw_memory[$thishost] = $F2 }
    if ($F1 eq "SpaceAlloc:")  {  $total_size = $F2 }
    if ($F1 eq "SpaceUsed:")   {  $total_used = $F2 }
    if ($F1 eq "MSSQLServiceStatus:")   { $servicestatus = $F2; }
    if ($F1 eq "HOSTNAME:")    {  $rmt_hostname[$thishost] = $F2; }
    if ($F1 eq "RSHService:")  {  $rsh_service[$thishost] = $F2; }
    if ($F1 eq "DB:")
    {
      $this_db = $F2;
      if ($F3 eq "CONNECTERROR")
      {
        &event("C",$thishost,"MSSQL Active But DB $F2 Is OFFLINE","MSSQLDBOff","DBA804C",$tmpfl3);
      }
      else
      {
	$zF3 = sprintf "%9.2f",$F3;
	$zF4 = sprintf "%9.2f",$F4;
	&logDetails($thishost,"<tr><td>$f_s $F2<td align=right>$f_s $zF3<td align=right>$f_s $zF4 <td align=right>$f_s $F5:$F6");

        #---- Log DB atrributes (if any)
        ##print "db_attrs=$db_attrs[$thishost]{$F2} F2=$F2\n";
        if ( $db_attrs[$thishost]{$F2} )
        {
	  &logDetails($thishost,"<td>$f_s ( $db_attrs[$thishost]{$this_db} )");
        }

	if ($g_history_to_file eq "Y")
	{
	  if ($hist_flag)
	  {
	    system("echo '$filedate $filetime $title[$thishost] $F2 . $F3 $F4 $dbms[$thishost]' >> $tmpflt");
	  }
        }

	# Create repository history data
	&histCreate("sqlUp()",$thishost,"SPC",$F2,$zF3,$zF4);

        #---- Save this for later
        $dbsize{$F2} = $F3;

        # Increment db counter
        $dbtot_mssql++;
        $gbtot_mssql += ($F3 / 1000);

        $dbcount[$thishost]++;
        if ($this_db ne "master" && 
            $this_db ne "model"  && 
            $this_db ne "msdb"   && 
            $this_db ne "tempdb")
        {
          $udbcount[$thishost]++;
        }

        $dblist[$thishost] .= $F2 . "\n";
      }
    }
  }
  close(TMPFL3);

  $ztotal_size = sprintf "%9.2f",$total_size;
  $ztotal_used = sprintf "%9.2f",$total_used;
  ##print "$ztotal_size $ztotal_used \n";
  &logDetails($thishost,"<tr bgcolor=slate>
    <th>$f_s Total ($dbcount[$thishost] DBs):
    <th align=right>$f_s $ztotal_size
    <th align=right>$f_s $ztotal_used
    <th align=right>$f_s $mrdate
  </tr>");
  &logDetails($thishost,"</table><hr>");

  if ($sw_version[$thishost] lt $ver_mssql_low  || $ver_mssql_low eq "" ) { $ver_mssql_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_mssql_high || $ver_mssql_high eq "") { $ver_mssql_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;  
  $system_used[$thishost] = $total_used / 1000;  
  ##print "su=$system_used[$thishost] $title[$thishost] \n";
  $grand_total_size += ($total_size / 1000);  

  # Check status
  if ($servicestatus eq "[Running]")
  {
    $dbmsg = "MSSQL Service IS Running";
  }
  else
  {
    $dbmsg = "MSSQL Service Is NOT Running";
  }
  if ($dbstats eq "")
  {
    $dbmsg .= ",Cannot Run SQL";
  }

  if ($dbstatus ne "UP")
  {
    $up[$thishost] = "N";
    &history_dummy($thishost);
    $hist_flag = 0;

    if ($t_mustbeup[$thishost] eq "Y")
    {
      &event("C",$thishost,"MSSQL Not Active: $dbstatus $dbmsg","MSSQLDown","DBA801",$tmpfl3) unless $cluster_thisnodestatus[$thishost] eq "Passive";
    }
    else
    {
      &event("I",$thishost,"MSSQL Not Active: $dbstatus $dbmsg","MSSQLDown","DBA801",$tmpfl3);
    }
  }
  else
  {
    $up[$thishost] = "Y";

    logit("OK",$thishost);
    if ($agentstatus ne "UP" && $mssql_agentmon[$thishost] ne "N")
    {
      &event("C",$thishost,"MSSQL Agent Service Not Active","AgentDown","DBA803C",$tmpfl3) unless $cluster_thisnodestatus[$thishost] eq "Passive";
    }
  }


  &logDetails($thishost,"<h3>MSSQL Instance Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");

  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Version:<td align=right>$f_s $sw_version[$thishost] $mssql64bit[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Up?<td align=right>$f_s $up[$thishost]<td>$f_s (Y or N)");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>STAR Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>STAR Contacts:<td>$f_s $star_contacts[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Cluster Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>Cluster Name:<td>$f_s $cluster_name[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>Cluster Global Status:<td>$f_s $cluster_status[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>Cluster On Node:<td>$f_s $cluster_onnode[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>Cluster This-Node Status:<td>$f_s $cluster_thisnodestatus[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>DoubleTake Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake Status:<td>$f_s $doubletake_status[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake Dir:<td>$f_s $doubletake_dir[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake File:<td>$f_s $doubletake_file[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake File Age Mins:<td>$f_s $doubletake_fileage_mins[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Type:<td align=right>$f_s $os[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Version:<td align=right>$f_s $os_version[$thishost] $os64bit[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Mode:<td align=right>$f_s $os_mode[$thishost]<td>$f_s (32, 64 or Blank)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Type:<td align=right>$f_s $hw_model[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory (MB):<td align=right>$f_s $hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Processor Count:<td align=right>$f_s $hw_processors[$thishost]");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Disk Drive Data (Disks That Contain MSSQL Database Files)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>$f_s Drive <th>$f_s Size (mB)<th>$f_s Used (mB)<th>$f_s Free (mB)<th>$f_s Percent Full</tr>");
  &logDetails($thishost,$diskdrivedata);
  &logDetails($thishost,"</table><hr>");

  if ($hist_flag)
  {
    &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
    system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
  }

  if ($oldperl_cnt > 0)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- Report of Old Perl Processes Which Should Be Killed:\n";
    print TMPFL2 "$oldperl_details";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- DOS Commands to Kill These Processes:\n";
    print TMPFL2 "$oldperl_kill";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- List of PIDs to Kill:\n";
    print TMPFL2 "$oldperl_pids";
    print TMPFL2 "$dashes\n";
    ##print TMPFL2 `cat $tmpfl3`;
    close(TMPFL2);
    &event("C",$thishost,"$oldperl_cnt Old Perl process(es) found - Max process age: $oldperl_maxage hours - Threshold: 12 hours","PerlOldProc","DBA802",$tmpfl2);
  }

  # Read SWVer data

  ##print "#swver_data=$#swver_data\n\n";
  ##foreach (@swver_data)
  ##{
  ##  print;
  ##  print "\n";
  ##}

  foreach $this_entry (@swver_data)
  {
    next if $this_entry !~ /^$dbmsout[$thishost]/;
    @words = split(/ /,$this_entry);
    $this_family = $words[1];
    $this_minver = $words[2];

    ##print "$titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    # Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);
    ##print "  z=$z \n";
    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
      last;
    }
  }

  # print "$P TLOG: $dbname $trunc $size $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space\n";
  # dbamon_mssql.pl TLOG: master Yes 1.24 48.86 E 80.56 E:\\MSSQL7\\data\\mastlog.ldf Unlimited
  foreach (split('\n',$tlogdata[$thishost]))
  {
    @words = split;
    $tl_dbname   = lc $words[2]; 
    $tl_trunc    = $words[3]; 
    $tl_tlsize   = $words[4]; 
    $tl_pctused  = $words[5]; 
    $tl_drive    = $words[6]; 
    $tl_drivepct = $words[7]; 
    $tl_filename = $words[8]; 
    $tl_growth   = $words[9]; 

    #---- dbsize{} includes the tlog size - subtract out - tl_dbsize will be the size of the db only
    $tl_dbsize   = sprintf "%.2f",($dbsize{$tl_dbname}) - $tl_tlsize;
    $tl_ratio    = sprintf "%.2f",($tl_tlsize / $tl_dbsize) if $tl_dbsize > 0;

    #if ($tl_growth =~ /KB$/)
    #{
    #  $tl_growth = ...
    #}

    ## print "tl_dbname=$tl_dbname tl_trunc=$tl_trunc tl_tlsize=$tl_tlsize tl_pctused=$tl_pctused tl_drive=$tl_drive\n";
    ## print "  tl_ratio=$tl_ratio tl_drivepct=$tl_drivepct tl_filename=$tl_filename tl_growth=$tl_growth tl_dbsize=$tl_dbsize\n";
    ## print "$titleraw[$thishost] - tl_dbname=$tl_dbname tl_ratio=$tl_ratio tl_tlsize=$tl_tlsize tl_dbsize=$tl_dbsize\n";

    $tl_ratio_threshold = 5;

    if ($tl_ratio >= $tl_ratio_threshold && $tl_tlsize >= 1000)
    {
      open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
      print TMPFL2 "DBName:                $tl_dbname\n";
      print TMPFL2 "Trunc_Log_On_Ckpt:     $tl_trunc\n";
      print TMPFL2 "TLog_Pct_Full:         $tl_pctused\n";
      print TMPFL2 "TLog_Size:             $tl_tlsize (mB)\n";
      print TMPFL2 "DBSize:                $tl_dbsize (mB)\n";
      print TMPFL2 "TLogSize_DBSize_Ratio: $tl_ratio\n";
      print TMPFL2 "TLog_File_Path:        $tl_filename\n";
      print TMPFL2 "TLog_Drive:            $tl_drive\n";
      print TMPFL2 "TLog_Drive_Pct_Full:   $tl_drivepct\n";
      print TMPFL2 "TLog_Growth_Setting:   $tl_growth\n";
      close(TMPFL2);
      &event("C",$thishost,"DB=$tl_dbname - TLog is $tl_ratio times DB size and TLog is >= 1gB (DBSize=$tl_dbsize (mB) TLSize=$tl_tlsize (mB) Threshold=$tl_ratio_threshold)","TLog-Size-Ratio","DBA656",$tmpfl2);
    }
  }

  #---- If there aren't any user dbs, warning event 
  &event("U",$thishost,"Non-System DB Count is Zero","No-User-DBs","DBA663") if $udbcount[$thishost] ne "" && $udbcount[$thishost] == 0;

  #---- DoubleTke stuff
  if ($is_threshold[$thishost] > 0)
  {
    if ($doubletake_fileage_mins[$thishost]  == 999999)
    {
      &event("C",$thishost,"InSync: DoubleTake File $doubletake_file[$thishost] is MISSING","InSyncAge","DBA665",$tmpfl3);
    }
    elsif ($doubletake_fileage_mins[$thishost] > $is_threshold[$thishost])
    {
      &event("C",$thishost,"InSync: DoubleTake File Age: $doubletake_fileage_mins[$thishost] (Min.) exceeds threshold of $is_threshold[$thishost] (Min.)","InSyncAge","DBA665",$tmpfl3);
    }

    if ($doubletake_status[$thishost] !~ /Running/)
    {
      &event("C",$thishost,"InSync: DoubleTake Server is NOT Running (Status: $doubletake_status[$thishost]","InSyncDown","DBA665",$tmpfl3);
    }
  }
}
# -----------------------------------------------------------------------------
1;
