select
  tabname Table,
  dbsname Database,
  count(*) Extents,
  sum(size)*2048 Total_Bytes
from
  sysextents
where
  dbsname != "HASHTEMP" and
  dbsname != "SORTTEMP" and
  tabname not like "sys%"
group by
  tabname,
  dbsname
order by
  3 desc
into temp
  dbamon_extents;

select
  *
from
  dbamon_extents
where
  Extents > 200;
