#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sum.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$color = "darkblue";
$| = 1;
$P = "dbamon_www_email.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$tmpfile = "/tmp/${P}_$$.txt";

$this_hostname = $ARGV[0];
$this_domain   = $ARGV[1];
$zcli =  $ARGV[2];
$ckin =  $ARGV[3];

$font = "verdana";

$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

$dbamon_userid = "dbamon";

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=lightgrey"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDBLARRY
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to LARRY Oracle DB");
  use DBI;
  $user = "system";
  $passwd = "pr0efx";
  $data_source = "DBI:Oracle";
  $database = "LARRY";

  $dbhStars = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
}


#-----------------------------------------------------------------------------
sub pingHost
#-----------------------------------------------------------------------------
{
  ##&msg("ping'ing Host=$Host ");

  $rc = system("/usr/sbin/ping $Host 64 1 | grep 'received, 0% packet loss' > /dev/null 2>&1");
  if ($rc != 0)
  {
    &msg("Cannot ping host=$Host - exiting");
    exit 1;
  }
  ##&msg("ping Successful");
}

#-----------------------------------------------------------------------------
sub getLARRY
#-----------------------------------------------------------------------------
{
  &msg("Selecting EMail Address information from LARRYS for Host/Domain $this_hostname/$this_domain");

  # Count tasks
  $statement  = "
    SELECT col1
    FROM 
      dbamon.billtest
  ";

  ##print "$statement\n";

  $sth = $dbhStars->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $rowcount = 0;
  
  print "\n";

  while (@Data = $sth->fetchrow_array)
  {
    &msg("Found data0 : <b>$Data[0]</b>");
  }
}




#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
  }
  
  chop($os = `grep ORACLE_SID:  $rcfile | awk '{ print \$2}'`);
  chop($oh = `grep ORACLE_HOME: $rcfile | awk '{ print \$2}'`);

  ##&msg("Setting Oracle Env.");
  $ENV{"ORACLE_SID"} = $os;
  $ENV{"ORACLE_HOME"} = $oh;
  ##system("env | grep ORACLE");

  chop($hostname = `hostname`);
  chop($date = `date`);
  chop($wsname = `hostname`);
  chop($wsnamef = `nslookup $wsname | grep Name: | awk '{ print \$2 }'`);

}
#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting this_hostname=$this_hostname this_domain=$this_domain arg3=$arg3 arg4=$arg4");

#&init;

&connectDBLARRY;
&getLARRY;

exit;

system("echo ' ' | mailx -m -s '$P ($zcli) $Host $email_addresses [AUTO]' bill_border\@agilent.com");

if ($email_addresses ne "")
{
  print " <ul><li><a href='mailto:$email_addresses'><b>Click Here To Send Outlook EMail To The Above $rowcount Addresses</b></a>
</ul>
";
}

&msg("Done");
system("rm $tmpfile > /dev/null 2>&1");
exit 0;
