#!/usr/local/bin/perl

$| = 1;
chop($P = `basename $0`); 

$os = $ENV{"ORACLE_SID"};

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n"; 
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user   = "dbatools";
  $passwd = "br0nc0s";
  $data_source = "DBI:Oracle";
  $database = $os;
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) || &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub doIt
#-----------------------------------------------------------------------------
{
  &msg("Selecting from DUAL"); 
  $sql  = "select * from dual"; 
  $sth = $dbh->prepare($sql) || &error('SQL Prepare');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $rowcount++; 
    &msg("Data[0]=$Data[0]");
  }
  &msg("Selected $rowcount rows"); 
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting"); 

&connectDB;
&doIt;

exit;
