#-------------------------------------------------------------
sub instanceDetails
#-------------------------------------------------------------
{
  my ($h) = @_;

  if ($use_oracle ne "Y") 
  {
    &logit("instanceDetails() Use_Oracle != Y - returning",$h);
    return;
  }
  if ($instance_details[$h] eq "") 
  {
    &logit("instanceDetails() h=$h No instance details for this instance - returning",$h);
    return;
  }

  #---- Delete old rows for this instance
  &logit("instanceDetails() Cleaning out Oracle dbamon.instance_details rows for instance_key=$instance_key[$h]");
  $sqlstmt = "delete from dbamon.instance_details where instance_key = '$instance_key[$h]'";
  runSQL($sqlstmt);

  foreach (split('\n',$instance_details[$h]))
  {
    $rec = $_;
    $cat   = (split(/\|/,$rec))[1] ;
    $parm  = (split(/\|/,$rec))[2] ;
    $value = (split(/\|/,$rec))[3] ;
    ##print "rec=$rec cat=$cat parm=$parm value=$value\n"; 

    $sqlstmt  = "insert into dbamon.instance_details
	(instance_key,category,parm,value)
      values
	('$instance_key[$h]','$cat','$parm','$value')";
    &runSQL($sqlstmt);
  }
}
#-------------------------------------------------------------------------------
1;
