# -----------------------------------------------------------------------------
sub oraAlerts
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  &remsh("/tmp/dbamon_ora.pl alertlog",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  $msgid = "";

  &logDetails($thishost,"<h3>Oracle Alert Log (last 100 lines)</h3>");
  &logDetails($thishost,"<pre>");

  open(TMPFL3, "$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;

    if ($F1 eq "alerttext:") 
    {
      chop($z = substr($F0,11));
      &logDetails($thishost,$z);
    }

    if ($F3 eq "ALERT") 
    {
      &event("C",$thishost,"Critical Messages Found in Oracle Alert Log","CritMsg","DBA611C",$tmpfl3);
    } 
  }
  close(TMPFL3);

  &logDetails($thishost,"</pre><hr>");

  if ($msgid eq "")
  {
    &logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
