# -----------------------------------------------------------------------------
sub oraDatafiles
{
  ($thishost) = @_;
  #
  # Check for offline datafiles
  #

  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  &remsh("/tmp/dbamon_ora.pl datafiles",$tmpfl3,$thishost);
  ##system("cat " tmpfl3)

  $msgid = "";
  $downflag = 0;

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F2 eq "DatafileDown:") { $downflag = 1 }
  }
  close(TMPFL3);

  if ($downflag) 
  {
    &event("C",$thishost,"OFFLINE Datafile(s) Found","OffDFs","DBA641C",$tmpfl3);
  } 
  else
  {
    logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
