# -----------------------------------------------------------------------------
sub oraExtents
{
  ($thishost) = @_;

  #
  # Check Oracle object extents
  #

  # Do this every 10th iteration
  if ($iter_count == 1 || ($iter_count/10 == int($iter_count/10)))
  {
    &logit("(Yes this iteration)",$thishost);
  }
  else
  {
    $s_flag = "N";
    &logit("(Not this iteration)",$thishost);
    return;
  }

  if ($t_extents[$thishost] eq "")
  {
    &logit("(Not Selected (T_Extents: is null)",$thishost);
    return 1;
  }

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  &remsh("/tmp/dbamon_ora.pl extents $t_extents[$thishost] $t_extents_fix[$thishost]",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  $okflag = "";

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F5 eq "OK") 
    {
      $okflag = 1;
    }
  }
  close(TMPFL3);

  if ($okflag)
  {
    &logit("OK",$thishost);
  }
  else
  {
    &event("U",$thishost,"Object(s) Found With Extents >= ${t_extents[$thishost]}% Of Max_Extents","Extents","DBA630U",$tmpfl3);
  }
}
# -----------------------------------------------------------------------------
1;
