# -----------------------------------------------------------------------------
sub oraLsnr
{
  ($thishost) = @_;
  #
  # Ensure that listener is active
  #

  if (&check_inhib($thishost) eq "Y" || $up[$thishost] eq "I")
  {
    $up[$thishost] = "I";
    $msg = sprintf("(down/inhibited)");
    &logit($msg,$thishost);
    return;
  }

  if ($up[$thishost] eq "D")
  {
    $msg = sprintf("(No software download)");
    &logit($msg,$thishost);
    $download_flag[$thishost] = 0;
    return;
  }

  &remsh("/tmp/dbamon_ora.pl lsnr",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F2 eq "NUMLSNR:")  { $numlsnr  = $F3 }
    if ($F2 eq "TNSPING:")  { $tnsping  = $F3 }
  }
  close(TMPFL3);

  $reason = "";
  if ($numlsnr lt "1") { $reason .= "(tnslsnr Not Running)" }
  if ($tnsping ne "1") { $reason .= "(tnsping Failed)" }

  # Add more here

  if ($reason ne "")
  {
    ##system("cat " tmpfl3)
    $msg = sprintf("!!! Listener Not Active: %s (Restart Was Attempted) !!!",$reason);
    $msgid = "DBA611C";
    $m_critical[$thishost]++;
    $short = "Lsnr";
    &logit($msg,$thishost);
    &crit_msg($msg,$thishost,$tmpfl3);
  }
  else
  {
    $msg = sprintf("OK");
    &logit($msg,$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
