#-----------------------------------------------------------------------------
# 
#   ####   #    #  #####    ####           #####   #    #
#  #       #    #  #    #  #               #    #  ##  ##
#   ####   #    #  #####    ####           #    #  # ## #
#       #  #    #  #    #       #   ###    #####   #    #
#  #    #  #    #  #    #  #    #   ###    #       #    #
#   ####    ####   #####    ####    ###    #       #    #
# 
#-----------------------------------------------------------------------------
sub parse
{
  ##print "before: $_";
  s/\\/\\\\/g;   # Change all backslashes to double backslashes
  ##print "after: $_";
  $F0 = $_;
  @words = split;
  $F1 = $F2 = $F3 = $F4 = $F5 = $F6 = $F7 = $F8 = $F9 = $F10 = $F11 = $F12 = $F13 = $F14 = $F15 = "";
  $NF = 0;
  if (substr($words[0],0,1) eq "#")
  {
    return;
  }
  for ($parse_i = 0; $parse_i <= $#words; $parse_i++)
  {
    $parse_z = $parse_i + 1;  # AWK array is relative to 1, not 0
    $words[$parse_i] =~ s/\@/\\\@/;
    $words[$parse_i] =~ s/"/'/g;
    $stmt = "\$F${parse_z} = \"$words[$parse_i]\"";
    ##print "stmt=$stmt \n";
    eval($stmt);
  }
  $NF = $#words + 1;
  return;
}

sub getdate
{
  ($sec,$min,$hour,$mday,$mon,$year) = localtime(time);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  $yy = sprintf("%04d",$year);
  $mm = sprintf("%02d",$mon);
  $dd = sprintf("%02d",$mday);
  $hh = sprintf("%02d",$hour);
  $mi = sprintf("%02d",$min);
  $ss = sprintf("%02d",$sec);

  $dw = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $dw;
}

#------------------------------------------------------------------------------
sub timeToText
#------------------------------------------------------------------------------
{
  my $zz_ts = $_[0];
  my ($sec,$min,$hour,$mday,$mon,$year) = localtime($zz_ts);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  my $yy = sprintf("%04d",$year);
  my $mm = sprintf("%02d",$mon);
  my $dd = sprintf("%02d",$mday);
  my $hh = sprintf("%02d",$hour);
  my $mi = sprintf("%02d",$min);
  my $ss = sprintf("%02d",$sec);

  my $date = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $date;
}
1;
