#-----------------------------------------------------------------------------
sub uptimeCalc
#-----------------------------------------------------------------------------
{
  $t = $_[0];

  # bb 02May02
  $count = 0;

  $statement  = "
    select
      avg(tot_pct),
      count(*)
    from 
      dbamon.uptime_summary
    where 
      instance = '$t'
      and ts >= sysdate - 30";
  ##print "statement=$statement\n";
  $sth2 = $dbh->prepare($statement) ||
          &error_msg('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error_msg('Failed_on_DB_execute_in_chgEnt');
  $u = "-1";
  while (@Data = $sth2->fetchrow_array)
  {
    $u     = $Data[0];
    $count = $Data[1];
  }

  if ($count > 0)
  {
    $u = sprintf("%5.1f",$u);
    if    ($u >= 99) { $c = "lime"; } 
    elsif ($u >= 95) { $c = "yellow"; } 
    else             { $c = "pink"; } 
    $s = "<font color=$c><h6>$u%</font>";
  }
  else 
  {
    $s = "";
  }
  #print "t=$t u=$u s=$s \n";
  return $s;
}
1;
